/*
 * payalnik1.c
 *
 * Created: 02.02.2017 15:10:08
 * Author : Алекс
 */ 

#define F_CPU 8000000

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h>

//                              0    1    2    3    4    5    6    7    8    9    H
const unsigned char codes[11]={0xf3,0x90,0xab,0xba,0xd8,0x7a,0x7b,0xb0,0xfb,0xfa,0xd9};

unsigned char data[4]={0x00,0x00,0x00,0x00};
unsigned char counter=0;

volatile int value = 0;
volatile int flag = 1;
volatile int flagsw = 0;
volatile int adc2 = 0;
volatile int flageeprom = 0;

unsigned char eeprom_var EEMEM; // определяем переменную в EEPROM

void init_pwm2( void )
{
	TCCR2 = ( 1<<WGM20 ) | ( 1<< WGM21 ) | ( 1<<COM21 );//fast FWM, off start(1<<CS21 to start)
	OCR2 = 0;
}

void init_adc( void )
{
	ADMUX |= (1 << REFS0) | (1 << REFS1) | (1 << MUX1) | (1 << ADLAR);//ADC1 and VCC
	ADCSRA |= (1 << ADEN)
	|(1 << ADPS2)|(1 << ADPS0)//64
	|(1 << ADIE);//isr
}

ISR(ADC_vect)
{
	adc2 = ADCH;
	TCCR2 |= _BV( CS21 );
}

void init_timer (void)
{ TIMSK=(1<<TOIE0);			//Enable timer overflow interrupt
	TCCR0=(0<<CS00)|(1<<CS01)|(0<<CS02);	//Prescaller = /1
}

void convert_data (unsigned int x)
{
	unsigned int temp,res;
	temp=x;
	
	res=temp/100;			//Calculate 100-s
	data[0]=codes[res];
	temp=temp-res*100;
if( res > 9 ) data[0]=codes[10];

	res=temp/10;			//Calculaate 10-s
	data[1]=codes[res];
	temp=temp-res*10;
	
	data[2]=codes[temp];		//Calculate 1-s
}

ISR (TIMER0_OVF_vect)
{
	PORTD=0xff;
	PORTB=_BV(counter);		//Enable digit
	PORTD=~data[counter];		//Write code
	counter=(counter+1)%3;		//Increment digit counter
	
	TCNT0=0x00;		        //Clear timer

	if( ( PINC & 48 ) == 16 && flag == 1 ) { value +=5; flag = 0; flageeprom = 1; }
	if( ( PINC & 48 ) == 32 && flag == 1 )
	{
		if( value ) value -=5;
		flag = 0;
		flageeprom = 1;
	}
	if( ( PINC & 48 ) == 48 ) flag = 1;
}

int main(void)
{
 
 int flagswpress = 1;
 
int e = 0, u = 0, i = 0;//, eprev = 0;
static int Ki = 1;
static int Kp = 1;
//static int Kd = 1;

 DDRD=0xff;
 PORTD=0x00;
 DDRB=0x0f;
 PORTB=0x07;
 DDRC  = 0;
 PORTC = 0xfb;
 //button PC3
 
 _delay_ms(100);
 //pause(1000);			//Settle pause
 init_timer(); 			//Init timer
 init_pwm2();
 init_adc();

 value = eeprom_read_byte(&eeprom_var);

 sei();

    while (1) 
    {
		TCCR2 &= ~_BV( CS21 );//остановка ШИМ
		_delay_ms( 1 );
		if( flageeprom ) { eeprom_write_byte( &eeprom_var , value ); flageeprom = 0; }
		ADCSRA |= _BV( ADSC );//запуск АЦП

//ПИД регулятор

e = value - adc2;

u = i + Ki * e;//И
i = u;

u += e * Kp;// П

//u += Kd * ( e - eprev );//Д
//eprev = e;

if( u > 255 ) u = 255;
if( u < 0 ) u = 0;
if( i > 255 ) i = 255;
if( i < 0 ) i = 0;

OCR2 = u;
//---------

	switch( flagsw )
	{
		case 1:
		convert_data( adc2 );//view ADC
		break;
		case 2:
		convert_data( u );//view PID
		break;
		default:
		convert_data( value );// view encoder
	}

		if( ( PINC & 0b1000 ) == 0 && flagswpress )//переключаем вывод на экран
		{
			flagsw++;
			flagsw = flagsw & 3;
			flagswpress = 0;
		}
		else if( ( PINC & 0b1000 ) ) flagswpress = 1;

		_delay_ms(15);
    }
}

